package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Predicate;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.AABB;

public class CleavingAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.CleavingAffix> CODEC;
  
  protected final Map<LootRarity, CleaveValues> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.mapCodec(CleaveValues.CODEC).fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.CleavingAffix::new));
  }
  
  private static boolean cleaving = false;
  
  public CleavingAffix(Map<LootRarity, CleaveValues> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat == LootCategory.HEAVY_WEAPON && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(100.0F * getChance(rarity, level)), Integer.valueOf(getTargets(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    float minChance = getChance(rarity, 0.0F);
    float maxChance = getChance(rarity, 1.0F);
    if (minChance != maxChance) {
      MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * minChance) });
      MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * maxChance) });
      comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
    } 
    int minTargets = getTargets(rarity, 0.0F);
    int maxTargets = getTargets(rarity, 1.0F);
    if (minTargets != maxTargets) {
      MutableComponent mutableComponent1 = Component.m_237113_(fmt(minTargets));
      MutableComponent mutableComponent2 = Component.m_237113_(fmt(maxTargets));
      return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
    } 
    return (Component)comp;
  }
  
  private float getChance(LootRarity rarity, float level) {
    return ((CleaveValues)this.values.get(rarity)).chance.get(level);
  }
  
  private int getTargets(LootRarity rarity, float level) {
    return ((CleaveValues)this.values.get(rarity)).targets.getInt(level);
  }
  
  public void doPostAttack(ItemStack stack, LootRarity rarity, float level, LivingEntity user, Entity target) {
    if (Apotheosis.getLocalAtkStrength((Entity)user) >= 0.98D && !cleaving && !(user.m_9236_()).f_46443_) {
      cleaving = true;
      float chance = getChance(rarity, level);
      int targets = getTargets(rarity, level);
      if ((user.m_9236_()).f_46441_.m_188501_() < chance && user instanceof Player) {
        Player player = (Player)user;
        List<Entity> nearby = target.m_9236_().m_6249_(target, (new AABB(target.m_20183_())).m_82400_(6.0D), (Predicate)cleavePredicate((Entity)user, target));
        for (Entity e : nearby) {
          if (targets > 0) {
            user.f_20922_ = 300;
            player.m_5706_(e);
            targets--;
          } 
        } 
      } 
      cleaving = false;
    } 
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
  
  public static Predicate<Entity> cleavePredicate(Entity user, Entity target) {
    return e -> {
        if ((e instanceof net.minecraft.world.entity.animal.Animal && !(target instanceof net.minecraft.world.entity.animal.Animal)) || (e instanceof net.minecraft.world.entity.npc.AbstractVillager && !(target instanceof net.minecraft.world.entity.npc.AbstractVillager)))
          return false; 
        if (!AdventureConfig.cleaveHitsPlayers && e instanceof Player)
          return false; 
        if (target instanceof net.minecraft.world.entity.monster.Enemy && !(e instanceof net.minecraft.world.entity.monster.Enemy))
          return false; 
        if (e != user && e instanceof LivingEntity) {
          LivingEntity le = (LivingEntity)e;
          if (le.m_6084_());
        } 
        return false;
      };
  }
}
